// ************************************************************* 
//
// *************************************************************
void Rx(byte seri)
{
 char cDataCnt = 0;
 byte b;

 if(seri == 1) // RS485
  cDataCnt = Serial1.available();  //RS485-Bus

 if(seri == 3) //TTL
  cDataCnt = Serial3.available();  // USART TTL

  
   if(cDataCnt > 0)
   { 
    if(seri == 1) // RS485
    { 
     RxBuf[seri][RxCnt[seri]] = b = Serial1.read();

     if(bMySlaveID == 1) // Software-Bridge für evtl. angeschlossene RS485 Module
      Serial3.write(b);  // Nur wenn eigene ID 1 ist werden die Daten von Serial1 (RS485) auf Serial3 (TTL) übertragen
    }
    
    if(seri == 3)//TTL   
    {
     RxBuf[seri][RxCnt[seri]] = b = Serial3.read();

     if(bMySlaveID == 1) // Software-Bridge für evtl. angeschlossene RS485 Module
      Serial1.write(b);  // Nur wenn eigene ID 1 ist werden die Daten von Serial3 (TTL) auf Serial1 (RS485) übertragen
    }
    
     preRxTime[seri] = actRxTime[seri] = micros();

    
     if(RxCnt[seri] == 3 && RxBuf[seri][3] != 0x11)  // Typ muss 0x11 sein
      RxCnt[seri] = 0;


     if(RxCnt[seri] == 8 && RxBuf[seri][8] != 0x3A)  // Ende muss 0x3A sein
      RxCnt[seri] = 0;


     if(RxBuf[seri][0] == 11) // Startbyte muss Längenangabe haben    
      RxCnt[seri]++;
     else
      RxCnt[seri] = 0;    
      
     
     if(RxCnt[seri] >= RxBuf[seri][0])
     { 
      if(CalcRxChkSum(seri)) 
      {

       if(RxBuf[seri][2] == bMySlaveID)
       {
        RxComActive[seri] = true;
        // Nachdem ein gültiger Befehl empfangen wurde, 
        // wird die Zeitdifferenz auf 0 gesetzt         
        preComTime[seri] = actComTime[seri]  = millis();               
        GetIO();
        TxBuf[seri][4]=bI[0];
        TxBuf[seri][5]=bI[1];
        TxBuf[seri][6]=bI[2];
        TxBuf[seri][7]=bI[3];

        bQ[4] = RxBuf[seri][4];
        bQ[5] = RxBuf[seri][5];
        bQ[6] = RxBuf[seri][6];
        bQ[7] = RxBuf[seri][7]; 
        SetOutput();

        if(bLinkMode != 0)  // Achtung wird verzögert aufgerufen wenn LinkMode != 0 ist
        {
         xStartTxTimer[seri] = true;
         actTxDelay[seri] = preTxDelay[seri] = millis();      
        }
        else
         Tx(seri);  
       }
      }
       else
      { // nicht  "b < RxCnt1" sondern "b < 11" weil bei falscher Datenübertragung
        // oder falscher Angabe bei Serial(1). das Rx-Array nicht vollständig gelöscht wird
       for(b = 0; b < 11; b++)
       {
        RxBuf[seri][b] = 0;       
       }
      }

     RxCnt[seri] = 0;
     }   
    }
 
}

// ************************************************************* 
//
// *************************************************************
bool CalcRxChkSum(byte seri)
{
 byte b;
 word ChkSum = 0;
 bool x = false;

 for( b=0; b <= RxBuf[seri][0]-3; b++)
 {
  ChkSum += RxBuf[seri][b]; 
 }

 if(ChkSum == (RxBuf[seri][9] + ((word)(RxBuf[seri][10] << 8))))
  x = true;

 return x;
}
