/*******************************************
/* SetConfig()
/*******************************************/
boolean SetConfig()
{ 
  boolean xOK = false;
 

  
  //Feststellen um welchen Befehl es sich handelt
 
  if(sCmd.indexOf("id:") == 0) // ist Kommando an 1. Position also Index == 0?
  {
   SetID();
   xOK = true;
  }

  if(sCmd.indexOf("pj7:") == 0) // ist Kommando an 1. Position also Index == 0?
  {
   SetPJ7();
   xOK = true;
  }  
 
  if(sCmd.indexOf("twi:") == 0 || sCmd.indexOf("i2c:") == 0 ) // ist Kommando an 1. Position also Index == 0?
  {
   SetTwi();
   xOK = true;
  } 

  if(sCmd.indexOf("lm:") == 0) // ist Kommando an 1. Position also Index == 0?
  {
   SetLinkMode();  
   xOK = true;
  }   
    
  return xOK;
}


/*******************************************
/* SetID()
/*******************************************/
void SetID()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
 String s = String(char(218)); // Entspricht Rechteck als Charakter
        
    if(c[3] >= '1' && c[3] <= '2')
    {
     bMySlaveID = c[3] - 48; // nummerischer Wert
    
   EEPROM.write(EE_MySlaveID, bMySlaveID);
   
   Serial.print(F("Device ID wurde auf "));
   Serial.print(bMySlaveID);
   Serial.println(F(" gesetzt")); 

   display.setTextColor(BLACK);
   display.setCursor(110, 33);   
   display.print(s); // vorherige ID mit schwarzem Rechteck im Display überschreiben


   display.setTextColor(WHITE);
   display.setCursor(110, 33);     
   display.print(bMySlaveID);
  }
  
  else
   Serial.println(F("Keine ID von 1...2 angegeben!"));   
  
}

/*******************************************
/* SetPJ7()
/*******************************************/
void SetPJ7()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
        
    if(c[4] >= '0' && c[4] <= '1')
    {
     if(c[4]== '0')
     {
      PORTJ &=  127;  //PIN J7 ausschalten
      Serial.print("Port J Bit 7 wurde ausgeschaltet\r\n");
     }
     else
     {
      PORTJ |=  128;  //PIN J7 einschalten
      Serial.print("Port J Bit 7 wurde eingeschaltet\r\n"); 
     }
  }
  else
   Serial.println("Kein Wert von 0...1 angegeben!");   
  
}

/*******************************************
/* SetTwi()
/*******************************************/
void SetTwi()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
      
    if(c[4] >= '0' && c[4] <= '1')
    {
     if(c[4]== '0')
     {
      TWCR = 0;
      EEPROM.write(EE_Twi,  xTwi = false);
      Serial.print("TWI (I2C) ausgeschaltet\r\n");
     }
     else
     {
      EEPROM.write(EE_Twi,  xTwi = true);
      Serial.print("TWI (I2C) eingeschaltet\r\n");
      display.ReIniDisplay();
     }
  }
  else
   Serial.println("Kein Wert von 0...1 angegeben!");   
}

/*******************************************
/* SetTL() Radio Link
/*******************************************/
void SetLinkMode()
{ 
 char c[16];
 sCmd.toCharArray(c, sCmd.length() +1 );
      
    if(c[3] >= '0' && c[3] <= '2')
    {
     switch(c[3])
     {
      case '0':
       EEPROM.write(EE_LinkMode,  bLinkMode = 0);
       bComFailureTime = 60;
       bDifTxDelay     = 0; 
       bSendComModeToMaster[3] = 0xA0;
       Serial3.write(bSendComModeToMaster, 4);
       delay(10);
       Serial.print(F("LinkMode: [0] TTL\r\n"));
      break;

      case '1':
       EEPROM.write(EE_LinkMode,  bLinkMode = 1);
       bComFailureTime = 100;
       bDifTxDelay     = 8;
       bSendComModeToMaster[3] = 0xA1;      
       Serial3.write(bSendComModeToMaster, 4);
       delay(100);            
       Serial.print(F("LinkMode: [1] RS485\r\n")); 
      break;

      case '2':
      if(bMySlaveID == 1)
      {
       EEPROM.write(EE_LinkMode,  bLinkMode = 2);
       bComFailureTime = 200;
       bDifTxDelay     = 16;
       bSendComModeToMaster[3] = 0xA2;      
       Serial3.write(bSendComModeToMaster, 4);
       delay(100);            
       Serial.print(F("LinkMode: [2] 3DR Radio Telemetrie\r\n"));
      }
      else
       Serial.print(F("LinkMode: [2] 3DR Radio Telemetrie ist nur mit Slave ID 1 moeglich\r\n"));
      
      break;       
     }

  }
    
  else
   Serial.println(F("Kein Wert von 0...2 angegeben!"));   
}
