/*******************************************
/* WatchDogSetup()
 * Moegliche Einstellungen
 * WDTO_15MS  -> 16ms
 * WDTO_30MS  -> 32ms
 * WDTO_60MS  -> 64ms
 * WDTO_120MS -> 125ms
 * WDTO_250MS -> 250ms
 * WDTO_500MS -> 500ms
 * WDTO_1S    -> 1s
 * WDTO_2S    -> 2s
 * WDTO_4S    -> 4s
 * WDTO_8S    -> 8s
/*******************************************/
void WatchDogSetup()
{
  //wdt_reset();
  wdt_enable(WDTO_1S);
  WDTCSR = (1<<WDIE);
}


/*******************************************
 * ISR(WDT_vect)
 * wird aufgerufen, wenn die Hauptschleife 
 * "void loop()" nicht innnerhalb in der   
 * voreingestellten Zeit "wdt_enable(WDTO_xx)"
 * durchlaufen wird
/*******************************************/
ISR(WDT_vect)
{
  cli();
  asm("WDR");
  // MCUSR &= ~(1<<WDRF);
  WDTCSR |= (1<<WDCE) | (1<<WDE);
  WDTCSR = 0x00;
  
  //Jeden Port auf Eingang stellen
  DDRA =  DDRB =  DDRC =  DDRD =  DDRE =  DDRF =  DDRG =  DDRH =  DDRJ =  DDRK = 0;
  //PullUps aus
  PORTA = PORTB = PORTC = PORTD = PORTE = PORTF = PORTG = PORTH = PORTJ = PORTK = 0; 

  //Nur Board LED PJ7 als einzigen µC-Pin auf Ausgang stellen.
  DDRJ =  B10000000; //Status LED

  // Endlosschleife Hardwarereset oder Ein-Aus-schalten erforderlich
  while(true)
  {
   LED_OFF 
   LED_ON
  }
}
